
clear all;
close all;
clc;

%fast read test -> 80Hz to 120Hz should be possible

timeTillCloseInSec = 10;
flgTestVibMotors = 1;
flgPlotFlexValues = 1; %1...22ms,0...9ms
flgPlotPWMValues = 0;

maxDt = 1e-3; %assuming a max framerate of 10ms
recordedData = nan(timeTillCloseInSec/maxDt,5);

if flgPlotFlexValues
    hFig=figure;
    set(hFig,'color','white');
end
if flgPlotPWMValues
    hFigPWM=figure;
    set(hFigPWM,'color','white');
end

%mapping btw. flex sensor and motors
%>700 -> 0
%445-700 -> 255...0
%<445 -> 255
flex2Pwd = inline('min(max(3*(700-flex),0),255)','flex');

elapsedTime = 0;

sensorGloveCtl = openSensorGloveConnection();
numReadings = 0;
tic
id = 1;

SensorGlove_EmptyBuffer( sensorGloveCtl )
flexValues = [];

while elapsedTime < timeTillCloseInSec
    
    %Reading
    Ready = SensorGlove_ReadyToRead( sensorGloveCtl );
    if Ready
        flexValues = readFlexSensors(sensorGloveCtl);
        if ~isempty(flexValues)
            numReadings = numReadings +1;
            recordedData(numReadings,:) = flexValues;
            
            if flgPlotFlexValues
                figure(hFig);
                bar(flexValues);
                axis([0,6,500,730]);
                drawnow;
            end
        end
    end 
    
    %Writing Motor Commands
    if flgTestVibMotors && ~isempty(flexValues) %&& mod(id,10)==0
        pwmValues = flex2Pwd(flexValues);
        writePWMValues(sensorGloveCtl, pwmValues);
        
        if flgPlotPWMValues && ~isempty(flexValues)
            figure(hFigPWM);
            bar(pwmValues);
            axis([0,6,0,255]);
            drawnow;
        end
    
    end
    
    
    elapsedTime = toc;
    id = id + 1;
end

%writePWMValues(sensorGloveCtl, [0 0 0 0 0]);
pause(1);
SensorGlove_EmptyBuffer( sensorGloveCtl );
closeSensorGloveConnection(sensorGloveCtl);
    
numSamplesPerSecond = numReadings/timeTillCloseInSec;
disp(['avg frame rate: ' num2str(numSamplesPerSecond) ' in Hz']);   

figure;
plot(recordedData(1:numReadings,:));


