function flexValues = readFlexSensors(sensorGloveCtl)
    
    in=fread(sensorGloveCtl,sensorGloveCtl.BytesAvailable,'char');
    startAsciiDez = 114; %'r'
    endAsciiDez = 120; %'x'
    startOfMsg = find(in==startAsciiDez,1,'first');
    endOfMsg = startOfMsg + find(in(startOfMsg+1:end)==endAsciiDez,1,'first');
    segment = in(startOfMsg:endOfMsg); 
    if length(segment) == 2+2*5+5 
        %fast, byte based processing
        %byte based: r highByteValue1 lowByteValue1 , ... , highByteValue5 lowByteValue5 x (17Bytes in total)
        
        flexValues = [0,0,0,0,0];
        for i=1:5
            flexValues(i) = segment(1+ (i-1)*3 + 1)*256 + segment(1+ (i-1)*3 + 2);
        end
    else
        flexValues = [];
    end

end